/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"nautaAlerts.h"
#include"nautaButtons.h"
#include"nautaFormLog.h"
#include"nautaForms.h"
#include"nautaStr.h"
#include"FormLog.h"
#include"FieldFunc.h"
#include"InitLog.h"
#include"InitSerial.h"
#include"InitTimer.h"
#include"events.h"
#include"log.h"
#include"prefs.h"
#include<PalmOS.h>
static FormType*f;static UInt16 port;static int kid,packsize=100,vex,initvex,hs;
static UInt32 NDBSize,iSent,jSent;static MemPtr rp;
static void RedOpenDb(void){CloseLogDb();OpenLogRW();}
static int moverecord(void)
{MemPtr r;int h;MemHandle rec;if(rp)MemPtrFree(rp);
 if(!(rec=GetRecord(iSent)))return 0;r=MemHandleLock(rec);h=MemPtrSize(r);
 rp=MemPtrNew(h);if(!rp)return 0;MemMove(rp,r,h);MemHandleUnlock(rec);iSent++;
 return h;
}
static void OnExit(void)
{if(!initvex)return;initvex=0;if(rp)MemPtrFree(rp);rp=0;SrmClose(port);
 InitSerial();InitTimer();RedOpenDb();if(vex)FrmAlert(kidAlertLogSent);
 AddMenuEvt(kidMenu);
}
static int SendLogTest(void)
{UInt32 n;CloseLogDb();OpenLogRO();n=LogDbSize();initvex=iSent=jSent=vex=0;
 rp=0;hs=0;packsize=GetTxRate()/20;packsize=packsize?packsize:1;
 if(n<1){FrmAlert(kidAlertNothingToSend);RedOpenDb();}
 NDBSize=n<1?0:n;return NDBSize<=0;
}
static void OnEnter(EventType*e)
{UInt32 n;char s[17];f=FrmGetFormPtr(kid=e->data.frmOpen.formID);initvex=0;
 if(SendLogTest()){AddMenuEvt(kidMenu);return;}FrmSetActiveForm(f);
 FrmDrawForm(f);n=GetTxRate();StrIToA(s,n);WinDrawChars(s,StrLen(s),70,20);
 CloseSerial();SrmOpen(0x8000,n,&port);StrIToA(s,NDBSize);hs=moverecord();
 WinDrawChars(s,StrLen(s),70,30);initvex=!0;CloseTimer();
}
static void SendLogLoop(void)
{static Err err;static char s[34];static Int32 b;if(!(initvex&&rp))return;
 if(iSent>=NDBSize){vex=NDBSize;OnExit();return;}
 err=SrmSendCheck(port,&b);if(b||err)return;StrIToA(s,iSent);
 s[b=StrLen(s)]=':';StrIToA(s+b+1,jSent);FrmCopyLabel(f,lab_Sent,s);
 b=(hs>=jSent+packsize)?packsize:hs-jSent;
 if(b>0)b=SrmSend(port,rp+jSent,b,&err);
 if(hs<=(jSent+=b)){jSent=0;hs=moverecord();}
}
Boolean SendFormHandler(EventType*e)
{switch(e->eType)
 {case ctlSelectEvent:if(!initvex)return 0;
   switch(e->data.ctlSelect.controlID)
   {case kidCancel:if(0==FrmAlert(kidAlertCancelSend))OnExit();break;
    case kidHelp:AddHelpEvt(kidHelpSend,kid);break;
   }break;
  case frmOpenEvent:OnEnter(e);break;case frmCloseEvent:OnExit();break;
 }SendLogLoop();return 0;
}
