/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"InitLog.h"
#include"log.h"
#include"nautaAlerts.h"
#include"nautaStr.h"
#include"FieldFunc.h"
#include"prefs.h"
#include"screen.h"
#include<PalmOS.h>
static LocalID LogDbID;static DmOpenRef LogDb;
void CloseLogDb(void){DmCloseDatabase(LogDb);}
void OpenLogRW(void)
{LogDbID=DmFindDatabase(0,DbName());
 LogDb=DmOpenDatabase(0,LogDbID,dmModeReadWrite);
}
void OpenLogRO(void)
{LogDbID=DmFindDatabase(0,DbName());
 LogDb=DmOpenDatabase(0,LogDbID,dmModeReadOnly);
}
UInt32 LogDbSize(void){UInt32 N;DmDatabaseSize(0,LogDbID,&N,0,0);return N;}
UInt32 LogDbBytesNo(void){UInt32 N;DmDatabaseSize(0,LogDbID,0,&N,0);return N;}
void logpacket(char*s,int n)
{UInt16 atP=dmMaxRecordIndex;MemPtr rp;MemHandle rec=DmNewRecord(LogDb,&atP,n);
 if(!rec){FrmAlert(kidAlert2);EnableLog(0);return;}
 rp=MemHandleLock(rec);DmWrite(rp,0,s,n);
 MemPtrUnlock(rp);DmReleaseRecord(LogDb,atP,1);
}
MemHandle GetRecord(UInt16 i){return DmQueryRecord(LogDb,i);}
static void dmcreatedbexpl(Err err,int y)
{char s[51];
 switch(err)
 {case dmErrInvalidDatabaseName:DrawStrRes(s,kidStrInvDbName,5,y);break;
  case dmErrAlreadyExists:DrawStrRes(s,kidStrAlrExist,5,y);break;
  case memErrCardNotPresent:DrawStrRes(s,kidStrNoCard,5,y);break;
  case dmErrMemError:DrawStrRes(s,kidStrMemErr,5,y);break;
  case memErrChunkLocked:DrawStrRes(s,kidStrLocked,5,y);break;
  case memErrInvalidParam:DrawStrRes(s,kidStrInvParam,5,y);break;
  case memErrInvalidStoreHeader:DrawStrRes(s,kidStrBadHeader,5,y);break;
  case memErrNotEnoughSpace:DrawStrRes(s,kidStrNoMem,5,y);break;
  case memErrRAMOnlyCard:DrawStrRes(s,kidStrRAMOnly,5,y);break;
  default:DrawStrRes(s,kidStrUnknErr,5,y);
 }
}
int InitLogDb(int wheretoscorn)
{char s[68];Err err;
 if(!(LogDbID=DmFindDatabase(0,DbName())))
 {SetWarnColor();DrawStrRes(s,kidStrMakeDb,5,wheretoscorn);
  if(err=DmCreateDatabase(0,DbName(),Creator(),DbType(),0))
  {SetFailColor();DrawStrRes(s,kidStrFail,120,wheretoscorn);
   dmcreatedbexpl(err,wheretoscorn+12);return 4;
  }SetOkColor();DrawStrRes(s,kidStrOk,120,wheretoscorn);
 }LogDbID=DmFindDatabase(0,DbName());
 if(!(LogDb=DmOpenDatabase(0,LogDbID,dmModeReadWrite)))return 5;return 0;
}
void ClearLogDb(void)
{DmCloseDatabase(LogDb);LogDbID=DmFindDatabase(0,DbName());
 DmDeleteDatabase(0,LogDbID);
 DmCreateDatabase(0,DbName(),Creator(),DbType(),0);
 LogDb=DmOpenDatabase(0,LogDbID,dmModeReadWrite);
}
