/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"nautaAlerts.h"
#include"nautaForms.h"
#include"SetReceiveFunc.h"
#include"GotoForm.h"
#include"FormCustom.h"
#include"FormGPS.h"
#include"FormHelp.h"
#include"FormLog.h"
#include"FormLogInfo.h"
#include"FormMenu.h"
#include"FormNav.h"
#include"FormPrefs.h"
#include"FormScroll.h"
#include"FormSys.h"
#include"events.h"
#include"formswitches.h"
#include"prefs.h"
#include"screen.h"
#include"serial.h"
#include"start.h"
#include"timer.h"
#include"nmea.h"
#include"hexa.h"
#include"taip.h"
#include"tsip.h"
#include"text.h"
#include<PalmOS.h>
static int kidForm;static void (*receivefunc)(void);
#define hic(a) a __attribute__ ((section("nauta")));a
hic(static Boolean emptyFormHandler(EventType*e)){return 0;}
hic(static FormEventHandlerType*HandlerSwitch(int k))
{switch(k)
 {case kidFormScroll:return ScrollFormHandler;
  case kidFormPrefs:return SettingsFormHandler;
  case kidFormSend:return SendFormHandler;case kidMenu:return MenuFormHandler;
  case kidFormNavInfo:return NavFormHandler;
  case kidFormSysInfo:return SysFormHandler;
  case kidFormGPSInfo:return GPSFormHandler;
  case kidFormLogInfo:return LogInfoFormHandler;
  case kidFormCustom:return CustomFormHandler;
  case kidFormHelp:return HelpFormHandler;
 }return emptyFormHandler;
}
hic(static Int16 WaitDelay(void))
{switch(kidForm){case kidFormSend:return 20;}return GetLoopDelay();}
static int waitdelay=20;
void GotoForm(int k)
{if(k<0){FrmAlert(kidAlert1);return;}if(k==kidForm)return;kidForm=k;
 if(!k){return;}FrmGotoForm(k);ResetFieldsColor();waitdelay=WaitDelay();
}typedef void(*rcvfn)(void);
hic(static rcvfn ReceiveSwitch(int x))
{switch(x)
 {case 0:return nmeareceive;case 1:return taipreceive;case 2:return tsipreceive;
  case 3:return hexareceive;case 4:return textreceive;
 }return textreceive;
}
void SetReceiveFunc(int Protocol){receivefunc=ReceiveSwitch(Protocol);}
#ifdef DIAG
char s[68];int N=0,Nmin=8192,Nmax=0,x=0;void SetN(int n){if(n)N=n;if(N>Nmax)Nmax=n;if(N<Nmin)Nmin=n;x++;}
#endif
hic(static int ApplicationHandleEvent(EventType*e))
{static Int16 X,Y,vex=0;static FormType*f;ProcessSerial();
 switch(e->eType)
 {case keyDownEvent:
   if(kidForm==kidFormHelp)return 0;
   switch(((struct _KeyDownEventType*)(&(e->data)))->chr)
   {case 11:GotoForm(PrevForm(kidForm));break;
    case 12:GotoForm(NextForm(kidForm));break;
    case 517:GotoForm(LeftForm(kidForm));break;
    case 518:GotoForm(RightForm(kidForm));break;
    case 261:if(kidForm!=kidFormSend)GotoForm(kidMenu);return 0;
    default:return 0;
   }break;
  case frmLoadEvent:f=FrmInitForm(e->data.frmLoad.formID);
   FrmSetEventHandler(f,HandlerSwitch(e->data.frmLoad.formID));break;
  case menuEvt:GotoForm(e->screenX);break;
  case helpEvt:X=e->screenX;Y=e->screenY;
   if(!vex){AddMenuEvt(kidFormHelp);};vex=!vex;return 0;
  case hlprdyEvt:AddHelpEvt(X,Y);break;
  case serEvt:
  #ifdef DIAG
   StrIToA(s,N);StrCat(s,":");StrIToA(s+StrLen(s),Nmin);StrCat(s,":");StrIToA(s+StrLen(s),Nmax);StrCat(s,"        ");WinDrawChars(s,StrLen(s),0,3);
  #endif
  receivefunc();break;case appStopEvent:break;default:return 0;
 }return!0;
}
hic(static int nextdelay(void))
{static UInt16 t;t=TicksToNextSec()+3;if(waitdelay<t)t=waitdelay;return t;}
hic(static void blink(void))
{
 #ifdef DIAG
 static int focus=0;static const int len=136;WinDrawLine(focus-2,0,focus-1,0);focus++;if(focus>=len)focus=0;WinEraseLine(focus,0,focus,0);
 #endif
}
hic(static void EventLoop())
{EventType e;char trapped,missStopEvt=0;
 do
 {EvtGetEvent(&e,nextdelay());trapped=0;blink();
  if(e.eType==keyDownEvent)
  {switch(((struct _KeyDownEventType*)(&(e.data)))->chr)
   {case 517:case 518:trapped=!0;missStopEvt=!0;break;}
  }if(e.eType==appStopEvent&&missStopEvt){missStopEvt=0;continue;}
  if(!trapped)if(SysHandleEvent(&e))continue;
  if(ApplicationHandleEvent(&e))continue;FrmDispatchEvent(&e);
 }while(e.eType!=appStopEvent);
}
UInt32 PilotMain(UInt16 cmd,void*cmdPBP,UInt16 launchFlags)
{if(!cmd){if(!Start()){EventLoop();Stop();}return 0;}return 1;}
