/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"nmea.h"

#include"dbnmea.h"
#include"events.h"
#include"hex.h"
#include"prefs.h"
#include"serial.h"
#include"setnavdata.h"
#include<PalmOS.h>
#define STRINT(a,b,c) ((((UInt32)(a))<<16)+(((UInt32)(b))<<8)+(c))
#define buflen 85 
#define hic(a) a __attribute__ ((section("prot")));a
hic(static char*getnmeafield(int n,char*s))
{int r;for(r=0;n>0&&r<buflen;n--)while(s[r++]!=','&&s[r]&&s[r]!='*'&&r<buflen);
 if(s[r]==','||s[r]=='*'||!s[r]||r>=buflen)return 0;return s+r;
}       
hic(static int checksum(char*s,int n))
{unsigned char c=0;while(n-->0&&*s!='*')c^=*s++;if(*s++!='*')return 0;
 return c^hex(s);
}
hic(static void GetnmeaStruct(char*MessType,char*str))
{UInt16 n;MemHandle rec;MemPtr rp;
 if(rec=GetDbNmeaRecord(STRINT(*MessType,MessType[1],MessType[2])))
 {rp=MemHandleLock(rec);n=MemPtrSize(rp);n=n<64?n:64;MemMove(str,rp,n);
  MemHandleUnlock(rec);str[n]=0;
 }
}static struct Angle a;        
hic(static char*parseLat(char*s))
{long deg,min,frac=0,expfrac=1,i;if(!s)return 0;
 deg=(*s-'0')*10+s[1]-'0';s+=2;min=(*s-'0')*10+s[1]-'0';s+=3;
 for(i=0;*s!=','&&i<3;i++){frac*=10;frac+=*s++-'0';expfrac*=10;} 
 while(i++<3){frac*=10;expfrac*=10;}
 while(*s!=','&&*s)s++;if(s[1]=='S')deg=-deg;
 a.deg=deg;a.min=min;a.sec=frac*60l/expfrac;
 a.frac=(frac-a.sec*expfrac/60)*1000/expfrac;SetLat(&a);return s+3;
}       
hic(static char*parseLon(char*s))
{long deg,min,frac=0,expfrac=1,i;if(!s)return 0;
 if(s[5]!='.'){deg=(*s-'0')*10+s[1]-'0';s+=2;}
 else{deg=(*s-'0')*100+(s[1]-'0')*10+s[2]-'0';s+=3;}
 min=(*s-'0')*10+s[1]-'0';s+=3;
 for(i=0;*s!=','&&i<3;i++){frac*=10;frac+=*s++-'0';expfrac*=10;} 
 while(i++<3){frac*=10;expfrac*=10;}
 while(*s!=','&&*s)s++;if(s[1]=='W')deg=-deg;
 a.deg=deg;a.min=min;a.sec=frac*60l/expfrac;
 a.frac=(frac-a.sec*expfrac/60)*1000/expfrac;SetLon(&a);return s+3;
}       
hic(static char*parseFixed(char*s,void(*Alt)(Int32)))
{UInt32 r=0;Int32 a;char sgn=1,i=0;if(*s=='-')sgn=-sgn,s++;if(*s=='+')s++;
 while(*s!='.'&&*s!=','&&*s){r*=10;r+=*s++-'0';}
 if(*s==','||!*s){a=r*sgn*FixedScale;Alt(a);return s+1;}
 s++;while(*s!=','&&*s&&i++<3){r*=10;r+=*s++-'0';}
 while(i++<3)r*=10;a=sgn*r;Alt(a);return s+1;
}       
hic(static UInt32 getms(char*s))
{UInt32 r;int h,m,sec,x10;
 h=(*s-'0')*10+s[1]-'0';m=(s[2]-'0')*10+s[3]-'0';sec=(s[4]-'0')*10+s[5]-'0';
 r=((h*60+m)*60l+sec)*FixedScale;if(s[6]==',')return r;
 for(sec=7,x10=100,m=0;sec<9&&s[sec]!=',';sec++,x10/=10)m+=(s[sec]-'0')*x10;
 return r+m*1000/FixedScale;
}
hic(static int parse(char*s,int i,UInt32 tic))
{int h;UInt32 utc;char Mess[4],MessStruct[64];
 if(checksum(s+1,i)){SndPlaySystemSound(sndWarning);if(CheckEnabled())return 0;}
 SetSensor(s+1);MemMove(Mess,s+3,3);s[i]=0;
 if(s[1]=='P'){PropSensor=STRINT(s[2],s[3],s[4]);Mess[1]|=0x80;Mess[4]=s[5];}
 GetnmeaStruct(Mess,MessStruct);
 for(h=0;MessStruct[h];h+=2)
 {switch(MessStruct[h])
  {case't':if(!(utc=getms(getnmeafield(MessStruct[h+1],s))))break;
    SetUTC(utc);setdifft(tic);break;
   case'l':parseLat(getnmeafield(MessStruct[h+1],s));break;
   case'o':parseLon(getnmeafield(MessStruct[h+1],s));break;
   case'a':parseFixed(getnmeafield(MessStruct[h+1],s),SetAlt);break;
   case'c':parseFixed(getnmeafield(MessStruct[h+1],s),SetCourse);break;
   case'H':parseFixed(getnmeafield(MessStruct[h+1],s),SetHeading);break;
   case's':parseFixed(getnmeafield(MessStruct[h+1],s),SetSpeed);break;
   case'w':SetWarning(getnmeafield(MessStruct[h+1],s));break;
   case'q':SetQuality(getnmeafield(MessStruct[h+1],s));break;
   case'n':SetSatsInView(getnmeafield(MessStruct[h+1],s));break;
   case'p':parseFixed(getnmeafield(MessStruct[h+1],s),SetHDOP);break;
   case'1':case'2':case'3':case'4':case'5':case'6':case'7':case'8':case'9':
    SetCustomVal(MessStruct[h]-'1',getnmeafield(MessStruct[h+1],s));break;
  }
 }return!0;
}        
void nmeareceive(void)
{static UInt32 t0=0;static char s[buflen];static int i=0;
 const char begin='$',end='\r';
 while(Receive(s+i))
 {if((s[i]>'z'&&s[i]<' ')&&!(s[i]=='\n'||s[i]=='\r'))*s=0;
  if(s[i]==begin){t0=TimGetSeconds();s[i=0]=begin;}
  if(*s==begin&&s[i]==end)
  {if(parse(s,i,t0)){SetScrollData(s,i);AddUserEvt(navEvt);}*s=~begin;}
  ++i;if(i>=buflen)s[i=0]=~begin;
 }
}
