/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include"InitPrefs.h"
#include"prefs.h"
#include"InitSerial.h"
#include"SetReceiveFunc.h"
#include<PalmOS.h>
#define DBNAME    "nautadb"
#define CREATOR   (('D'<<24)+('T'<<16)+('I'<<8)+' ')
#define DBTYPE    (('n'<<24)+('m'<<16)+('d'<<8)+'b')
static const int maxprot=4;static UInt32 RxMax;
static char CustomFields[72],logEn,adjEn,checkEn,stayEn,rxprot;
static UInt32 Rxr,Txr,LoopDelay,serflags;static UInt16 AutoOff;
UInt32 GetRxRate(void){return Rxr;}UInt32 GetTxRate(void){return Txr;}
int SetRxRate(UInt32 x)
{if(Rxr==x||x<=0)return 0;if(x>RxMax)x=RxMax;Rxr=x;return!0;}
void SetTxRate(UInt32 x){if(Txr==x||x<=0)return;if(x>RxMax)x=RxMax;Txr=x;}
UInt32 GetSerFlags(void){return serflags;}
int GetBits(void)
{switch(serflags&srmSettingsFlagBitsPerCharM)
 {case srmSettingsFlagBitsPerChar5:return 0;
  case srmSettingsFlagBitsPerChar6:return 1;
  case srmSettingsFlagBitsPerChar7:return 2;
  case srmSettingsFlagBitsPerChar8:return 3;
 }return 3;
}
int SetBits(int x)
{if(x==GetBits())return 0;
 serflags&=~srmSettingsFlagBitsPerCharM;
 switch(x)
 {case 0:serflags|=srmSettingsFlagBitsPerChar5;break;
  case 1:serflags|=srmSettingsFlagBitsPerChar6;break;
  case 2:serflags|=srmSettingsFlagBitsPerChar7;break;
  case 3:default:serflags|=srmSettingsFlagBitsPerChar8;break;
 }return!0;
}
int GetParity(void)
{if(serflags&srmSettingsFlagParityOnM){if(serflags&srmSettingsFlagParityEvenM)
 return 2;else return 1;}return 0;
}
int SetParity(int x)
{if(GetParity()==x)return 0;if(x--)serflags|=srmSettingsFlagParityOnM;
 else{serflags&=~srmSettingsFlagParityOnM;return!0;}
 if(x)serflags|=srmSettingsFlagParityEvenM;
 else serflags&=~srmSettingsFlagParityEvenM;return!0;
}
int GetStopBits(void)
{if(srmSettingsFlagStopBits2==(serflags&srmSettingsFlagStopBitsM))return 1;
 return 0;
}
int SetStopBits(int x)
{if(x==GetStopBits())return 0;serflags&=~srmSettingsFlagStopBitsM;
 if(x)serflags|=srmSettingsFlagStopBits2;
 else serflags|=srmSettingsFlagStopBits1;return!0;
}
UInt32 GetLoopDelay(void){return LoopDelay;}
void SetLoopDelay(UInt32 x){LoopDelay=x;}
void StayOn(int x)
{stayEn=x;if(x)SysSetAutoOffTime(0);else SysSetAutoOffTime(AutoOff);}
int StayEnabled(void){return stayEn;}int LogEnabled(void){return logEn;}
int syncEnabled(void){return adjEn;}int CheckEnabled(void){return checkEn;}
void EnableLog(int en){logEn=en;}void EnableSync(int en){adjEn=en;}
void EnableCheck(int en){checkEn=en;}int GetProtocol(void){return rxprot;}
void SetProtocol(int p){rxprot=p>maxprot?0:p;SetReceiveFunc(GetProtocol());}
static void InitFlags(void)
{UInt16 port;Int16 s;UInt32 f;Err err=SrmOpen(0x8000,1200,&port);
 if(err)return;if(!err)err=SrmControl(port,srmCtlGetFlags,&f,&s);
 if(!err)serflags=f;else serflags=0;SrmClose(port);
}
static int DefaultPrefs(void)
{DeviceInfoType pi;
 if(SrmGetDeviceInfo(0,&pi))
 {pi.serDevMaxBaudRate=19200;pi.serDevHandshakeBaud=9600;}
 RxMax=pi.serDevMaxBaudRate;SetRxRate(4800);SetTxRate(pi.serDevHandshakeBaud);
 SetLoopDelay(SysTicksPerSecond()/2);EnableLog(0);EnableSync(0);
 EnableCheck(0);StayOn(1);SetProtocol(0);MemSet(CustomFields,72,0);
 InitFlags();return SetBits(4)||SetParity(0)||SetStopBits(0);
}
void SetDefaultPrefs(void){if(DefaultPrefs()){CloseSerial();InitSerial();};}
void SavePrefs(void)
{UInt32 n;char prefs[90];SysSetAutoOffTime(AutoOff);
 *prefs=(syncEnabled()?1:0)|(LogEnabled()?2:0)|(CheckEnabled()?4:0)|
        (StayEnabled()?8:0);
 n=GetRxRate();MemMove(prefs+1,&n,4);n=GetTxRate();MemMove(prefs+5,&n,4);
 MemMove(prefs+13,CustomFields,72);prefs[85]=(char)(GetProtocol());
 MemMove(prefs+86,&serflags,4);
 PrefSetAppPreferences(CREATOR,0,0,prefs,90,true);
}
int ReadPrefs(void)
{UInt32 n;UInt16 n16,size=0;char*pr;MemHandle m;
 AutoOff=SysSetAutoOffTime(0);DefaultPrefs();
 if(PrefGetAppPreferences(CREATOR,0,0,&size,true))return!0;
 m=MemHandleNew(size);pr=(char*)(MemHandleLock(m));
 PrefGetAppPreferences(CREATOR,0,pr,&size,true);if(!size)goto x;
 EnableLog(2&*pr);EnableSync(1&*pr);EnableCheck(4&*pr);StayOn(8&*pr);
 if(size<5)goto x;MemMove(&n,++pr,4);Rxr=n;
 if(size<9)goto x;MemMove(&n,pr+=4,4);SetTxRate(n);
 if(size<11)goto x;MemMove(&n16,pr+=4,2);
 if(size<13)goto x;MemMove(&n16,pr+=2,2);
 if(size<85)goto x;MemMove(CustomFields,pr+=2,72);
 if(size<86)goto x;SetProtocol((int)*(pr+=72));
 if(size<90)goto x;MemMove(&serflags,++pr,4);
 x:MemHandleUnlock(m);MemHandleFree(m);return 0;
}
UInt32 Creator(void){return CREATOR;}UInt32 DbType(void){return DBTYPE;}
char*DbName(void){return DBNAME;}
char*GetCustomFieldName(unsigned i){return CustomFields+((i<9)?i*8:0);}
void SetCustomFieldName(unsigned i,char*s)
{char*d=CustomFields+(i<9?i*8:0);for(i=0;i<7&&*s;*d++=*s++,i++);*d=0;}
