/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include<stdio.h>
#include<malloc.h>
int CheckFopen(FILE**f,const char*n,const char*m)
{*f=fopen(n,m);if(!f){fprintf(stderr,"can't open %s\n",n);return!0;}return 0;}
unsigned char*RecList=0;unsigned short RecNum,FirstEntry;
unsigned short GetUShort(FILE*f){return (fgetc(f)<<8)|fgetc(f);}
unsigned long GetULong(FILE*f)
{return ((unsigned long)(fgetc(f))<<24)|((unsigned long)(fgetc(f))<<16)|
        ((unsigned long)(fgetc(f))<<8)|fgetc(f);
}
void ReadHeader(FILE*f)
{unsigned long X,x;
 printf("Name: \"");for(x=0;x<32;x++)printf("%c",fgetc(f));printf("\"\n");
 printf("Attributes: 0x%4.4X; ",GetUShort(f));
 printf("Version: %uh\n",GetUShort(f));
 printf("Created: %ul; ",GetULong(f));printf("Modified: %ul; ",GetULong(f));
 printf("BackUp: %ul\n",GetULong(f));
 printf("Modification Number: %ul\n",GetULong(f));
 printf("AppInfoID: %ul; ",GetULong(f));printf("SortInfoID: %ul\n",GetULong(f));
 X=GetULong(f);
 printf("Type: \"%c%c%c%c\"; ",
  (char)(X>>24),(char)(X>>16),(char)(X>>8),(char)X);
 X=GetULong(f);
 printf("Creator: \"%c%c%c%c\"\n",
  (char)(X>>24),(char)(X>>16),(char)(X>>8),(char)X);
 printf("UniqueIDSeed: %ul; ",GetULong(f));
 printf("NextRecordListID: %ul\n",GetULong(f));
 printf("Number of Records: %uh\n",RecNum=GetUShort(f));
}
void GetRecList(FILE*db)
{unsigned long i;RecList=malloc(RecNum*8);
 for(i=0;i<RecNum*8;RecList[i++]=fgetc(db));
}
unsigned long GetRecPos(unsigned short i)
{return i>RecNum-1?0:
        ((unsigned long)(RecList[8*i])<<24)|
        ((unsigned long)(RecList[8*i+1])<<16)|
        ((unsigned long)(RecList[8*i+2])<<8)|(unsigned long)(RecList[8*i+3]);
}
unsigned long GetRecID(unsigned short i)
{return ((unsigned long)(RecList[8*i+5])<<16)|
        ((unsigned long)(RecList[8*i+6])<<8)|(unsigned long)(RecList[8*i+7]);
}
void WriteList(FILE*db,char*f)
{int i;unsigned long pos;FILE*txt;if(CheckFopen(&txt,f,"wb"))return;
 GetRecList(db);pos=78+8*RecNum;while(!feof(db)){i=fgetc(db);
 if(!feof(db))fputc(i,txt);}fclose(txt);
}
void printhelp(char*s)
{printf("Palm database files conversion utility\n"
  "usage: %s infilename outfilename\n",s);
}
void FreeMemory(void){if(RecList)free(RecList);}
int main(int argc,char**argv)
{FILE*db;if(argc<2){printhelp(*argv);return 1;}
 if(CheckFopen(&db,argv[1],"rb"))return 2;
 printf("converting %s to %s...\n",argv[1],argv[2]);
 ReadHeader(db);WriteList(db,argv[2]);FreeMemory();fclose(db);return 0;
}
