/*  nauta for Palm: displays and logs serial data from GPS sensors
    Copyright (C) 2002 D.T.Ineiev, super V 93
    Email: <ineiev@yahoo.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include<stdio.h>
#define NAME "./dbnmea"
#define VERSION 0
#define MaxStrLength 34
int CheckFopen(FILE**f,const char*n,const char*m)
{*f=fopen(n,m);if(!f){fprintf(stderr,"can't open %s\n",n);return!0;}return 0;}
int ReadString(FILE*txt,char*s)
{while((*s=fgetc(txt))!='\n'&&!feof(txt))s++;
 *s=s[MaxStrLength]=0;if(s[-1]<' ')s[-1]=0;return!feof(txt);
}
unsigned short NumberOfRecords(char*f)
{FILE*txt;unsigned long i;if(CheckFopen(&txt,f,"rt"))return 0;
 for(i=0;!feof(txt);)if('\n'==fgetc(txt))i++;fclose(txt);return i;
}
unsigned long RecordLength(char*s)
{unsigned long i,n;
 for(i=0;s[i++]!='|';);for(n=i;s[n++]>=' ';);
 return (i==4||i==6)?(n-i-1)/3*2:n-i-1;
}
void WriteULong(FILE*f,unsigned long x)
{fputc((x>>24)&0xFF,f);fputc((x>>16)&0xFF,f);fputc((x>>8)&0xFF,f);
 fputc(x&0xFF,f);
}
void WriteUShort(FILE*f,unsigned short x)
{fputc((x>>8)&0xFF,f);fputc(x&0xFF,f);}
void WriteName(FILE*db)
{int i;char*s=NAME;for(i=0;s[i];fputc(s[i++],db));while(i++<32)fputc(0,db);
}
void WriteAttributes(FILE*db){WriteUShort(db,0);}
void WriteVersion(FILE*db){WriteUShort(db,VERSION);}
void WriteCreationDate(FILE*db){WriteULong(db,17);}
void WriteModificationDate(FILE*db){WriteULong(db,17);}
void WriteLastBackUpDate(FILE*db){WriteULong(db,17);}
void WriteModificationNumber(FILE*db){WriteULong(db,0);}
void WriteAppInfoID(FILE*db){WriteULong(db,0);}
void WriteSortInfoID(FILE*db){WriteULong(db,0);}
void WriteType(FILE*db)
{fputc('n',db),fputc('m',db);fputc('d',db);fputc('b',db);}
void WriteCreator(FILE*db)
{fputc('D',db),fputc('T',db);fputc('I',db);fputc(' ',db);}
void WriteUniqueIDSeed(FILE*db){WriteULong(db,17);}
void WriteUniqueID(FILE*db,char*s)
{if(s[2]=='|'){fputc(0,db);fputc(*s++,db);fputc(*s++,db);return;}
 if(s[3]=='|'){fputc(*s++,db);fputc(*s++,db);fputc(*s++,db);return;}
 if(s[4]=='|'){s++;fputc(0x80|*s++,db);fputc(*s++,db);fputc(*s++,db);return;}
 if(s[5]=='|'){s++;fputc(*s++,db);fputc(0x80|*s++,db);fputc(*s++,db);return;}
}
void WriteRecordEntries(FILE*db,unsigned long pos,char*f)
{FILE*txt;char s[128];if(CheckFopen(&txt,f,"rt"))return;
 while(ReadString(txt,s))
 {WriteULong(db,pos);pos+=RecordLength(s);fputc(0,db);WriteUniqueID(db,s);}
 fclose(txt);
}
void WriteRecordList(FILE*db,char*f)
{unsigned short RecNum=NumberOfRecords(f);printf("Records: %u\n",RecNum);
 WriteULong(db,0);WriteUShort(db,RecNum);if(!RecNum){WriteUShort(db,0);return;}
 WriteRecordEntries(db,78+RecNum*8,f);
}
int WriteRecords(FILE*db,char*f)
{FILE*txt;char s[128];int i;if(CheckFopen(&txt,f,"rt"))return 1;
 while(ReadString(txt,s))
 {i=0;while(s[i++]!='|');if(i!=2&&i!=4)while(s[i])fputc(s[i++],db);
  else while(s[i]){fputc(s[i++],db);fputc((s[i]-'0')*10+(s[i+1]-'0'),db);i+=2;}
 }fclose(txt);return 0;
}
void WriteHeader(FILE*db,char*f)
{WriteName(db);WriteAttributes(db);WriteVersion(db);WriteCreationDate(db);
 WriteModificationDate(db);WriteLastBackUpDate(db);WriteModificationNumber(db);
 WriteAppInfoID(db);WriteSortInfoID(db);WriteType(db);WriteCreator(db);
 WriteUniqueIDSeed(db);WriteRecordList(db,f); 
}
void printhelp(char*s)
{printf("nauta text-to-database conversion utility\n"
   "usage: %s infile outfile\n",s);
}
int main(int argc,char**argv)
{FILE*db;int r;if(argc<2){printhelp(*argv);return 2;}
 if(CheckFopen(&db,argv[2],"wb"))return 3;
 printf("creating %s from %s...\n",argv[2],argv[1]);
 WriteHeader(db,argv[1]);r=WriteRecords(db,argv[1]);fclose(db);return r;
}
